/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: j_acth.c,v 1.2 2001/07/26 12:23:43 cxsc Exp $ */

#include "fi_lib.h" 


#ifdef LINT_ARGS
local interval j_acth(interval x)
#else
local interval j_acth(x)

interval x;
#endif
{
 interval res;

 if (x.SUP<-1)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_acth(x.INF);
      res.SUP=res.INF*q_actm;
      res.INF*=q_actp;
    }
   else
    {
      res.INF=q_acth(x.SUP)*q_actp;
      res.SUP=q_acth(x.INF)*q_actm;
    } 
 }    
 else if(x.INF>1)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_acth(x.INF);
      res.SUP=res.INF*q_actp;
      res.INF*=q_actm;
    }
   else
    {
      res.INF=q_acth(x.SUP)*q_actm;
      res.SUP=q_acth(x.INF)*q_actp;
    }  
 }
 else   /* invalid argument */
 {

      res=q_abortr2(INV_ARG,&x.INF,&x.SUP,25);

 }
 return(res);
}


