/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: j_asin.c,v 1.2 2001/07/26 12:23:43 cxsc Exp $ */

#include "fi_lib.h" 



#ifdef LINT_ARGS
local interval j_asin(interval x)
#else
local interval j_asin(x)

interval x;
#endif
{
  interval res;
  if (x.INF==x.SUP)             /* point interval */
    { 
       if (x.INF<0)
        {
          if (x.INF>-q_atnt)
            {
               res.INF=r_pred(x.INF);
               res.SUP=x.INF;
            }
          else
            {
              res.INF=q_asin(x.INF);
              res.SUP=res.INF*q_csnm;
              res.INF*=q_csnp;
              if (res.SUP>x.INF) res.SUP=x.INF;
            } 
        }
       else 
         {
           if (x.INF<q_atnt)
             {         
               res.INF=x.INF;
               if (x.INF==0)
                  res.SUP=0; 
               else
                  res.SUP=r_succ(x.INF);
             }
           else
             {
                res.INF=q_asin(x.INF);
                res.SUP=res.INF*q_csnp;
                res.INF*=q_csnm;
                if (res.INF<x.INF) res.INF=x.INF;
              }
        }
    }
  else
    {
      if (x.INF<0)
        {
          if (x.INF>-q_atnt)
            res.INF=r_pred(x.INF); 
          else
            res.INF=q_asin(x.INF)*q_csnp;          
        }
      else  /* x.INF>=0 */
        {
          if (x.INF<q_atnt)
            res.INF=x.INF;      
          else 
            {
              res.INF=q_asin(x.INF)*q_csnm;
              if (res.INF<x.INF) res.INF=x.INF;
            }
        }
      if (x.SUP<=0)
        {
          if (x.SUP>-q_atnt)
            res.SUP=x.SUP;
          else
            {
              res.SUP=q_asin(x.SUP)*q_csnm;
              if (res.SUP>x.SUP) res.SUP=x.SUP;
            }          
        }
      else  /* x.SUP>0 */
        {
          if (x.SUP<q_atnt)
            res.SUP=r_succ(x.SUP);         /* includes the case x.SUP=0 */       
          else 
            res.SUP=q_asin(x.SUP)*q_csnp;
        }
    }   
  return(res);
}

