/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: j_coth.c,v 1.2 2001/07/26 12:23:43 cxsc Exp $ */

#include "fi_lib.h" 



#ifdef LINT_ARGS
local interval j_coth(interval x)
#else
local interval j_coth(x)

interval x;
#endif
{
 interval res;

 if (x.SUP<0)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_coth(x.INF);
      res.SUP=res.INF*q_cthm;
      res.INF*=q_cthp;
    }
   else
    {
      res.INF=q_coth(x.SUP)*q_cthp;
      res.SUP=q_coth(x.INF)*q_cthm;
    } 
   if (res.SUP>-1) res.SUP=-1.0;
 }    /* end  if (x.SUP<0) */
 else if(x.INF>0)
 {
   if (x.INF==x.SUP)             /* point interval */
    { 
      res.INF=q_coth(x.INF);
      res.SUP=res.INF*q_cthp;
      res.INF*=q_cthm;
    }
   else
    {
      res.INF=q_coth(x.SUP)*q_cthm;
      res.SUP=q_coth(x.INF)*q_cthp;
    }  
   if (res.INF<1) res.INF=1.0;
 }
 else   /* invalid argument */
 {

   res=q_abortr2(INV_ARG,&x.INF,&x.SUP,21);

 }
 return(res);
}


