/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: j_ex10.c,v 1.2 2001/07/26 12:23:43 cxsc Exp $ */

#include "fi_lib.h" 



#ifdef LINT_ARGS
local interval j_ex10(interval x)
#else
local interval j_ex10(x)

interval x;
#endif
{
 interval res;
  if (x.INF==x.SUP)                  /* point interval */
    { 
      if ((x.INF>=0) && (x.INF<=22) && (CUTINT(x.INF)==x.INF))
        {  
          res.INF=q_ex10(x.INF);
          res.SUP=res.INF;
        }
      else if (x.INF<=q_extn)
        { 
          res.INF=0.0;
          res.SUP=q_minr;
        }
      else 
        { 
          res.INF=q_ex10(x.INF);
          res.SUP=res.INF*q_e10p;
          res.INF*=q_e10m;
        }
    }
  else
    {
      if (x.INF<=q_extn) 
        res.INF=0.0;
      else if ((CUTINT(x.INF)==x.INF) && (x.INF>=0) && (x.INF<=22))
        res.INF=q_ex10(x.INF);
      else
        res.INF=q_ex10(x.INF)*q_e10m;
      if (x.SUP<=q_extn)
        res.SUP=q_minr;
      else if ((CUTINT(x.SUP)==x.SUP) && (x.SUP>=0) && (x.SUP<=22))
        res.SUP=q_ex10(x.SUP);
      else  
        res.SUP=q_ex10(x.SUP)*q_e10p;
    }   
  if (res.INF<0.0) res.INF=0.0;
  if ((x.SUP<=0.0) && (res.SUP>1.0)) res.SUP=1.0;
  if ((x.INF>=0.0) && (res.INF<1.0)) res.INF=1.0;

 return(res);
}

