/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: j_expm.c,v 1.2 2001/07/26 12:23:43 cxsc Exp $ */

#include "fi_lib.h" 


#ifdef LINT_ARGS
local interval j_expm(interval x)
#else
local interval j_expm(x)

interval x;
#endif
{
  interval res;
  if (x.INF==x.SUP)                     /* point interval */
    { 
       if (x.INF<0)
        {
          if (x.INF>-q_minr)
            {
               res.INF=x.INF;
               res.SUP=r_succ(x.INF);
            }
          else
            {
              res.INF=q_expm(x.INF);
              res.SUP=res.INF*q_exmm;
              res.INF*=q_exmp;
            } 
        }
       else 
         {
           if (x.INF<q_minr)
             {         
               res.INF=x.INF;
               if (x.INF==0)
                  res.SUP=0; 
               else
                  res.SUP=r_succ(x.INF);
             }
           else
             {
                res.INF=q_expm(x.INF);
                res.SUP=res.INF*q_exmp;
                res.INF*=q_exmm;
              }
        }
    }
  else
    {
      if (x.INF<=0)
        {
          if (x.INF>-q_minr)
            res.INF=x.INF;                 /* includes case x.INF=0 */
          else
            res.INF=q_expm(x.INF)*q_exmp;          
        }
      else  /* x.INF>0 */
        {
          if (x.INF<q_minr)
            res.INF=x.INF;      
          else 
            res.INF=q_expm(x.INF)*q_exmm;
        }
      if (x.SUP<0)
        {
          if (x.SUP>-q_minr)
            res.SUP=r_succ(x.SUP);
          else
            res.SUP=q_expm(x.SUP)*q_exmm;          
        }
      else  /* x.SUP>=0 */
        {
          if (x.SUP<q_minr)
            res.SUP=r_succ(x.SUP);        
          else 
            res.SUP=q_expm(x.SUP)*q_exmp;
        }
    }   

  if (res.INF<-1.0) res.INF=-1.0;
  return(res);
}

