/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: j_log2.c,v 1.2 2001/07/26 12:23:43 cxsc Exp $ */

#include "fi_lib.h" 



#ifdef LINT_ARGS
local interval j_log2(interval x)
#else
local interval j_log2(x)

interval x;
#endif
{
 interval res; 
  if (x.INF==x.SUP)                  /* point interval */
    { 
      res.INF=q_log2(x.INF);
      if (res.INF>=0) 
        {
          res.SUP=res.INF*q_lg2p;
          res.INF*=q_lg2m;
        }
      else
        {
          res.SUP=res.INF*q_lg2m;
          res.INF*=q_lg2p;
        }
    }
  else
    {
      res.INF=q_log2(x.INF);
      if (res.INF>=0)
        res.INF*=q_lg2m;
      else
        res.INF*=q_lg2p;
      res.SUP=q_log2(x.SUP);
      if (res.SUP>=0)
        res.SUP*=q_lg2p;
      else
        res.SUP*=q_lg2m;
    }   

 return(res);
}

