/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: j_sqr.c,v 1.2 2001/07/26 12:23:44 cxsc Exp $ */

#include "fi_lib.h" 


#ifdef LINT_ARGS
local interval j_sqr(interval x)
#else
local interval j_sqr(x)

interval x;
#endif
{
  interval res;


  if (x.INF==x.SUP)                       /* point interval */
    { 
      if (x.INF==0)
        res.INF=res.SUP=0;
      else { res.INF=q_sqr(x.INF); 
             res.SUP=r_succ(res.INF);
             res.INF=r_pred(res.INF);
           }
    }
  else
    {
      if NANTEST(x.INF)                     /* Test: x.inf=NaN */
        res.INF=q_abortnan(INV_ARG,&x.INF,1);
      else if NANTEST(x.SUP)                /* Test: x.sup=NaN */
        res.SUP=q_abortnan(INV_ARG,&x.SUP,1);
      else {
        if ((x.INF<-q_sqra)||(x.SUP>q_sqra))
          res=q_abortr2(OVER_FLOW,&x.INF,&x.SUP,1);
        else if (x.INF==0) 
          { res.INF=0; res.SUP=r_succ(x.SUP*x.SUP); }
        else if (x.INF>0)
          { res.INF=r_pred(x.INF*x.INF); res.SUP=r_succ(x.SUP*x.SUP); }
        else if (x.SUP==0)
          { res.INF=0; res.SUP=r_succ(x.INF*x.INF); }
        else if (x.SUP<0)
          { res.INF=r_pred(x.SUP*x.SUP); res.SUP=r_succ(x.INF*x.INF); }
        else 
          { res.INF=0;
            if (-x.INF>x.SUP) res.SUP=r_succ(x.INF*x.INF);
            else              res.SUP=r_succ(x.SUP*x.SUP);          
          }
      } 

    }   

  return(res);
}


