/*
**  CXSC is a C++ library for eXtended Scientific Computing
**
**  Copyright (C) 1990-2000 Institut fuer Angewandte Mathematik,
**                          Universitaet Karlsruhe, Germany
**            (C) 2000-2001 Wiss. Rechnen/Softwaretechnologie
**                          Universitaet Wuppertal, Germany   
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* CVS $Id: q_prnt.c,v 1.3 2001/07/30 13:30:22 cxsc Exp $ */

#include "fi_lib.h" 
#include <stdio.h>

void printup(double x)
{  
  if (x==(double)CUTINT(x)) printf("%23.15e",x);
  else if (abs(x)>(1e17-1)*1e27) printf("%23.15e",q_succ(q_succ(x)));
  else printf("%24.15e",q_succ(x));
}

void printdown(double x)
{
  if (x==(double)CUTINT(x)) printf("%23.15e",x);
  else if (abs(x)>(1e17-1)*1e27) printf("%24.15e",q_pred(q_pred(x)));
  else printf("%23.15e",q_pred(x));
  
}

void printInterval(interval x)
{ 
  printf("[");
  printdown(x.INF);
  printf(",");
  printup(x.SUP);
  printf(" ]");
}


